// Siemens C504 example - David Lively, 
#pragma db oe sb cd
// db == debug in OBJ
// oe == extended debug in OBJ
// sb == include symbols in OBJ
// cd == include assembly code in LST
#include <reg51.h>
#include <stdio.h>
#include <stdlib.h>

void indirect0(long d) {
  long count=0;
  
  for(count=0;count<d;count++);
}

void indirect1(long d) {
  long count=0;
  
  for(count=0;count<d;count++);
}

void indirect2(long d) {
  long count=0;
  
  for(count=0;count<d;count++);
}




void (*f)(long i); // function pointer - used to call a function at random

void *farr[3] = {indirect0,indirect1,indirect2}; // array of function addresses


void main(void) {
  long count=0;
  
//initialize 8051 serial port
	SCON  = 0x50;
	TMOD |= 0x20;
	TH1	= 0xf3;
	TR1	= 1;
	TI	= 1;
  

  srand(64); // reseed random number generator

	printf("-- Start Execution -- \n");
  while(1) {

     f= farr[rand()%3]; // pick a function at random
     f(10000); // call the function and let it loop   
  }
}
